﻿/*
	Martrinex Lovefilm Gadget 1.000
	Last modified: 17th October 2007
	By: Martin Sykes (Martrinex)
	Website: http://gadgets.martrinex.net
	Email: admin@martrinex.net
	
	This is a third party gadget not made or supported in anyway by lovefilm.com 
	for tech support please contact me using the details above.

	About:
		for lovefilm.com members.
		downloads a list of films currently booked out, so you can tell instantly what films you have
		and what films are currently being posted to you.

		this gadget connects, logins and downloads the films using HTTP
		unfortunatly this means changes to lovefilm.com may break this gadet.
	Dependencies:
		msxml2.serverxmlhttp 1,2,3,4,5 or 6 (used for communication and cookie handling)
*/

var xmlhttp=null;								// handles communication with lovefilm.com
var cookie="";									// hold cookie to confirm we are a web browser (well...)
var email="";
var password="";
var controls=new Array(),cc=0;	// hold controls to be able to delete (on refresh)
var refreshTime = 20*60*1000 		// refresh every 20 minutes
var refreshTicker = 0						// timer handler
var fin=0;											// holds pos of text found in the getBetween function

/* initialize gadget
	 create the HTTPXML object
	 get the email and password
	 create status labels
	 if no email and password show optoins ELSE begin 3 stage download (cookie->login->dvd data)
*/
function view_onOpen() {
	xmlhttp = createXMLobj();
	if(xmlhttp==null) return;

	email = options.getValue("email");
	password = options.getValue("password");

	maindiv.appendElement("<label name='lblstatus' width='100%' height='20' y='0'>Gadget Loading...</label>");
	maindiv.appendElement("<a name='btnrefresh' onclick='getCookie();' y='18' width='100%' height='20'>Refresh</a>");
	maindiv.appendElement("<a name='btnerror' visible='false' y='35' size='8' width='100%' height='40' wordwrap='true' href='http://lovefilm.com'>Lovefilm might be updating please check their site</a>");

	if(email==""||password==""){
		showOptions();
	}else{
		getCookie();
	}
}

/*
	 loadup the options div, and create the controls.
	 or just make visible if its been used once already
*/
function showOptions(){
	maindiv.visible=false;
	if(typeof(divoptions)=="undefined"){
		view.appendElement("<div name='divoptions' y='25' width='150' height='125' />");
		divoptions.appendElement("<label size='8' x='2' y='40' width='35%'>Email:</label>");
		divoptions.appendElement("<edit size='7' y='40' x='38%' height='18' width='59%' name='txtuser' />");
		if(email!="") txtuser.value=email;
		divoptions.appendElement("<label size='8' x='2' y='60' width='35%'>Password:</label>");
		divoptions.appendElement("<edit y='60' x='38%' height='18' width='59%' passwordChar='*' name='txtpass' />");	
		divoptions.appendElement("<button onclick='updateOptions();' height='18' width='54' x='90' y='80' downImage='stock_images\\button_down.png' image='stock_images\\button_up.png' overImage='stock_images\\button_over.png' caption='Submit'/>");
		divoptions.appendElement("<button onclick='divoptions.visible=false;' height='18' width='54' x='35' y='80' downImage='stock_images\\button_down.png' image='stock_images\\button_up.png' overImage='stock_images\\button_over.png' caption='Cancel'/>");
		divoptions.appendElement("<label italic='true' wordwrap='true' size='8' y='0' x='2' width='90%' height='40'>Warning your password is sent as plain text, then encoded and saved locally.</label>");
	}else{
		divoptions.visible=true;
	}
}

/*
	 save new email and password and beging 3 stage download process.
*/
function updateOptions(){
	divoptions.visible=false;
	email = txtuser.value;
	password = txtpass.value;
	options.putValue("email",email);
	options.putValue("password",password);
	//options.encryptValue("password");
	getCookie();
}

/* start of login process
	 simple download ANY page from lovefilm.com and store the cookie,
	 proving the browser has saw the site before, and avoiding future browser checks.
*/
function getCookie(){
	// recheck every 20mins, use timeout instead of interval to keep more control
	if(refreshTicker > 0) view.clearTimeout(refreshTicker);
	refreshTicker = view.setTimeout(getCookie,refreshTime);
	// date object used to make sure page is not cache
	var date = new Date();
	// init things
	destroyDVDs(); 				// get rid of old dvd list
	maindiv.visible=true;	// make sure its visible (after exiting options)
	/* bug fix
	re-create xml object to prevent sending an old cookie and connecting to wrong account 
	(ie: user changes options and trys another lovefilm.com account)
	*/
	xmlhttp = null;
	xmlhttp = createXMLobj();
	if(xmlhttp==null) return;
	// set current status
	lblstatus.visible=btnrefresh.visible=true;
	lblstatus.innerText="Finding lovefilm...";
	// download ANY page from lovefilm to save time only get the HEADer (we dont need the rest)
	xmlhttp.open("GET", "http://www.lovefilm.com/visitor/home.html?"+date.getTime(), true);
	xmlhttp.onreadystatechange = getcookieDATA;
	xmlhttp.send();
}

function getcookieDATA(){
	if(xmlhttp.readyState!=4) return;
	cookie = xmlhttp.getResponseHeader("set-cookie");
	/* fix 24/10/07, site was down for maintence gadget... only said "logging on..." */
	if(cookie==""){
		lblstatus.innerText="Cannot get cookie";
		btnerror.visible=true;
	}else{
		getlogin();
	}
}

/* login process
	 submit our email and password to: http://www.lovefilm.com/visitor/login.html
	 make sure our form encoding is set properly
*/
function getlogin(){
	var date = new Date(); // stop xmlhttp cache
	lblstatus.innerText = "Logging on...";
//	xmlhttp = new ActiveXObject("Msxml2.ServerXMLHTTP.4.0");
	// POST the form data to the server.. 
	// would be great if we could just get the HEAD here but protocol doesnt allow this
	xmlhttp.open("POST", "http://www.lovefilm.com/visitor/login.html?"+date.getTime(), true);
	xmlhttp.setRequestHeader("Content-Type","application/x-www-form-urlencoded"); //our form encoding, actually its plain/text but this stops server errors
	xmlhttp.setRequestHeader("Cookie", cookie);
	xmlhttp.onreadystatechange = getloginDATA;
	xmlhttp.send("logincmd=login&email="+email+"&password="+password); // send username and password as plain text	
}

function getloginDATA(){
	if(xmlhttp.readyState!=4) return;
	cookie = xmlhttp.getResponseHeader("set-cookie");
	getdvds();
}

/* assume logged on passed
	 for some reason using xmlhttp gives no indication of access denied error unlike pure protocol
	 use our cookie again to proof our selves, you could save the cookie in options.setvalue since lovefilm
	 doesn't seem to retched or revalidate cookies... ever! but just incase we always start the process from
	 scratch.
*/
function getdvds(){
	var date = new Date();
	lblstatus.innerText="Downloading dvd's...";
	xmlhttp.open ("GET", "http://www.lovefilm.com/account/selection.html?"+date.getTime(), true);
	xmlhttp.setRequestHeader("Cookie", cookie);
	xmlhttp.onreadystatechange = getdvdsDATA;
	xmlhttp.send();
}

function getdvdsDATA(){
	if(xmlhttp.readyState!=4) return;
	html = xmlhttp.responseText;
	// quick check to see if we got login page again (password failed)
	if(html.indexOf("<strong>Password</strong>") > -1){
		showOptions();
		alert("Incorrect username and/or password");
	}else{
	// beging reading dvd's
		extractHTML(html);
		btnerror.visible=false;
	}
}

/* extract dvd data from html, note if lovefilm changes their page the code will break.
	 use only the html between "Titles at home " and the end of that table "</table>"
	 then fetch each table row skipping the first one as a header and ignoring the last....
	 lovefilm can only have 4 dvds (at time of writing) 3=max package+1 special offers/ocasions

	 note we could also extract what is next on your list... (possible future version)
*/
function extractHTML(html){
	lblstatus.visible=btnrefresh.visible=false;
	var title=""; diskdate="";
	var i=0,y=0,ypos=0;
	var gotheader=false;
	// get section of html which contains "Titles at home, to the end of the table
	html = getBetween(html,"Titles at home ","</table>");
	// fetch each row "tr" one at a time, disk per row excluding 1st row (header) and last row (empty)
	dvd = getBetween(html,"<tr>","</tr>");
	html = html.substring(fin);
	while(fin!=-1){
		i++; // count our rows
		if(i <=5){ // limit of 3 dvd's at lovefilm (4 on special occasions)
			if(gotheader){ // 1st row is header
				if(dvd.indexOf("colspan=")==-1) cols=5; else cols=1;
				for(y=1; y<=cols; y++){
				data = getBetween(dvd,">","</td>");
				dvd = dvd.substring(fin);
				//if(i==3) alert(data+" "+y+" "+dvd);
					switch(y){
						case 1: 
							if(cols==1){	// message like "awaiting alocation"
								title=data; diskdate="";
							}else{				// rented disk
								title=data;
							}
							//if(i==3) alert(title);
						break;
						//case 2: break; 	// rental list name
						//case 3: break; 	// rating
						case 4: diskdate=data; break; // date / disk allocated just cant be bothered to send
						//case 5: break; 	// report problem
					}
				}
				// create the controls
				if(title!="&nbsp;"){
					if(diskdate==""){
						if(title.indexOf("Awaiting allocation") > -1) title= "Awaiting allocation";		
						/* graphics update 24/10/07 */
						controls[cc]=	maindiv.appendElement("<img width='16' height='16' x='2' y='"+parseInt(ypos+15)+"' src='stock_images/wait.png' />");
						controls[cc]=maindiv.appendElement("<label bold='true' size='8' y='"+ypos+"' width='100%' height='20'>Disk "+(i-1)+": not sent yet.</label>");
						controls[cc+1]=maindiv.appendElement("<label size='8' x='18' y='"+parseInt(ypos+20)+"' width='132' height='20'>"+title+"</label>");
						cc+=2;
					}else{
						img=getBetween(title,' src="','"');
						url=getBetween(title,' href="','"');
						title=getBetween(title,'">','</a>');
						// if we have the image here... use it
						img = img.substring(indexOfrev(img,"/")+1);
						if(img=="12.gif"||img=="15.gif"||img=="18.gif"||img=="pg.gif"||img=="u.gif")
						if(diskdate.indexOf("Provisional allocation") > -1) diskdate= "Allocated"; // povisional allocation fix
						controls[cc]=	maindiv.appendElement("<img width='16' height='16' x='2' y='"+parseInt(ypos+15)+"' src='stock_images/"+img+"' />");
						controls[cc+1]=maindiv.appendElement("<label bold='true' size='8' y='"+ypos+"' width='148' height='13'>Disk "+(i-1)+": "+diskdate+"</label>");
						controls[cc+2]= maindiv.appendElement("<a wordwrap='true' x='18' size='8' y='"+parseInt(ypos+13)+"' width='132' height='27' href='"+url+"'>"+title+"</a>");
						cc+=3;
					}
					ypos+=38;
				}
			}else{
				//fix 20 oct 07, extra "no dvd's at home row" when no dvd's are at home... so locate the th header
				if(dvd.indexOf("<th ") > -1){ i=1; gotheader=true; }
			}
			// proceed to next row/disk
			dvd = getBetween(html,"<tr>","</tr>");
			html = html.substring(fin);
		}else{
			// too many rows get out before we get stuck
			fin=-1;
		}
	}
}

// get the last / from a url
function indexOfrev(stack, search){
	var pos = -1;
	for(var i=stack.length; i > 0; i--){
		pos = stack.indexOf(search,i);
		if(pos > -1) return pos;
	}
	return pos;
}

// search through HTML easiest way possible
function getBetween(stack, begining, ending){
	start = stack.indexOf(begining);
	if(start!=0) start+=begining.length;
	end = stack.indexOf(ending,start);
	if(start==0||end==0){ fin=-1; return ""; }
		fin = end+ending.length;
		return stack.substring(start,end);
}

// destroy our elements and get ready for the next elements
// we do this incase the # of dvd's changes.
function destroyDVDs(){
	for(i=0;i<cc;i++){
		debug.trace(i+" "+cc);
		if(controls[i]!=null)	maindiv.removeElement(controls[i]);
		controls[i]=null;
	}
	cc=0;
}

// create a XMLHTTP object, use the server version to avoid bugs and server issues regarding cookies.
function createXMLobj(){
	var tmlxml=null;
	try
	{
		// try and get the lattest avaliable version
		tmpxml = new ActiveXObject("Msxml2.ServerXMLHTTP.6.0"||"Msxml2.ServerXMLHTTP.5.0"||"Msxml2.ServerXMLHTTP.4.0"||"Msxml2.ServerXMLHTTP.3.0"||"Msxml2.ServerXMLHTTP.2.0"||"Msxml2.ServerXMLHTTP");
	}
	catch(e)
	{	
		// server version does not have to be on every machine so give download link :-(
		ele = maindiv.appendElement("<a wordwrap='true' width='100%' height='100%'>Please download server XML, needed to send cookies to lovefilm.com and logon.</a>");
		ele.href="http://www.microsoft.com/downloads/thankyou.aspx?familyId=8167837e-0983-4988-99a4-377ef5c0da2e&displayLang=en";
		return null;
	}
 return tmpxml;
}